import { ApplicationCommandOption, ApplicationCommandOptionChoice, ApplicationCommandOptionType, PartialApplicationCommand } from "./structures";
export declare class CommandBuilder {
    private name;
    private description;
    private options;
    constructor();
    setName(name: string): CommandBuilder;
    setDescription(description: string): CommandBuilder;
    addOption(option: ApplicationCommandOption): CommandBuilder;
    build(): PartialApplicationCommand;
}
export declare class SubcommandBuilder {
    type: ApplicationCommandOptionType;
    name: string;
    description: string;
    default?: boolean;
    required?: boolean;
    options: ApplicationCommandOption[];
    constructor();
    setName(name: string): SubcommandBuilder;
    setDescription(description: string): SubcommandBuilder;
    setDefault(def: boolean): SubcommandBuilder;
    setRequired(required: boolean): SubcommandBuilder;
    addOption(option: ApplicationCommandOption): SubcommandBuilder;
    build(): ApplicationCommandOption;
}
export declare class SubcommandGroupBuilder {
    type: ApplicationCommandOptionType;
    name: string;
    description: string;
    default?: boolean;
    required?: boolean;
    options: ApplicationCommandOption[];
    constructor();
    setName(name: string): SubcommandGroupBuilder;
    setDescription(description: string): SubcommandGroupBuilder;
    setDefault(def: boolean): SubcommandGroupBuilder;
    setRequired(required: boolean): SubcommandGroupBuilder;
    addOption(option: ApplicationCommandOption): SubcommandGroupBuilder;
    build(): ApplicationCommandOption;
}
export declare class ApplicationCommandOptionBuilder {
    type: ApplicationCommandOptionType;
    name: string;
    description: string;
    default?: boolean;
    required?: boolean;
    choices?: ApplicationCommandOptionChoice[];
    constructor();
    setType(type: ApplicationCommandOptionType): ApplicationCommandOptionBuilder;
    setName(name: string): ApplicationCommandOptionBuilder;
    setDescription(description: string): ApplicationCommandOptionBuilder;
    setDefault(def: boolean): ApplicationCommandOptionBuilder;
    setRequired(required: boolean): ApplicationCommandOptionBuilder;
    addChoice(choice: ApplicationCommandOptionChoice): this;
    build(): ApplicationCommandOption;
}
