"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.verifySignature = void 0;
const tweetnacl_1 = require("tweetnacl");
const verifySignature = (publicKey, signature, timestamp, rawBody) => __awaiter(void 0, void 0, void 0, function* () {
    return tweetnacl_1.sign.detached.verify(Buffer.from(timestamp + rawBody), Buffer.from(signature, "hex"), Buffer.from(publicKey, "hex"));
});
exports.verifySignature = verifySignature;
